local nameToMapId = {}

if TomTom then
	local lmd = LibStub("LibMapData-1.0")
	local mapIds = lmd:GetAllMapIDs()
	for idx, mapId in ipairs(mapIds) do
		local mapName = lmd:MapLocalize(mapId)
		nameToMapId[mapName] = mapId
	end
end

-- Slash Command
SLASH_HOLIDAYHELPER1 = "/holidayhelper"
SLASH_HOLIDAYHELPER2 = "/hh"
SlashCmdList["HOLIDAYHELPER"] = function (args) holidayhelper_onSlash(args) end

local holidayhelper_start = nil
local holidayhelper_enable = true
local holidayhelper_hasHolidayDebuff = false
local holidayDebuffWarningMsg = "Holiday debuff clear!"
local holidayhelper_playerFaction = nil
local holidayhelper_scryerHated = false
local holidayhelper_aldorHated = false
local holidayhelper_staticWaypoints = {}
local holidayhelper_playerName = nil

local holidayhelper_activeHolidays = {	hallowsEnd=0,
										pilgrimsBounty=0,
										winterVeil=0,
										lunarFestival=0,
										loveIsInTheAir=0,
										noblegarden=0,
										midsummerFireFestival=0,
										brewfest=0
									}

local holidayhelper_scannedPlayers = {}
local holidayhelper_trackedPlayers = {}
local holidayhelper_raceClassCombosTracking = {}

function holidayhelper_onEvent (self, event, ...)
	local unit = ...
	-- Is it the right Spellevent?
	if(holidayhelper_enable and event == "UNIT_AURA" and unit == "player") then
                local holidayDebuffFound = false
                for i=1,40 do 
                        local n =UnitAura("player",i)
                        if (n == "Mistletoe") then
                             holidayDebuffFound = true
                             holidayhelper_hasHolidayDebuff = true
                             holidayDebuffWarningMsg = "Mistletoe debuff clear, go /kiss a Winter Reveler!"
                        end
                end
                if (holidayDebuffFound == false) then     
                        if (holidayhelper_hasHolidayDebuff == true) then
                              RaidNotice_AddMessage(RaidBossEmoteFrame, holidayDebuffWarningMsg, { r = 0, g = 1, b = 0 })
                              PlaySoundFile("Sound\\interface\\RaidWarning.wav")
                        end
                        holidayhelper_hasHolidayDebuff = false
                end

	end
	
	if event == "QUEST_QUERY_COMPLETE" then
		if holidayhelper_enable then
			holidayhelper_onEnable()
		end
	end
	
	if event == "PLAYER_LOGIN" then
		QueryQuestsCompleted()
		holidayhelper_getActiveHolidays()
		holidayhelper_getFactionInfo()
		if (holidayhelper_activeHolidays["lunarFestival"] == 1) then
			holidayhelper_print("Holiday Helper - Happy Lunar Festival! (01/22 - 02/11)")
		end
		if (holidayhelper_activeHolidays["loveIsInTheAir"] == 1) then
			holidayhelper_print("Holiday Helper - Happy Love is in the Air! (02/05 - 02/20)")
		end
		if (holidayhelper_activeHolidays["noblegarden"] == 1) then
			holidayhelper_print("Holiday Helper - Happy Noblegarden! (04/08 - 04/15)")
		end
		if (holidayhelper_activeHolidays["midsummerFireFestival"] == 1) then
			holidayhelper_print("Holiday Helper - Happy Midsummer Fire Festival! (06/21 - 07/05)")
		end
		if (holidayhelper_activeHolidays["brewfest"] == 1) then
			holidayhelper_print("Holiday Helper - Happy Brewfesht! *hic!* (09/20 - 10/05)")
		end
		if (holidayhelper_activeHolidays["hallowsEnd"] == 1) then
			holidayhelper_print("Holiday Helper - Happy Hallow's End! (10/18-10/31)")
		end
		if (holidayhelper_activeHolidays["pilgrimsBounty"] == 1) then
			holidayhelper_print("Holiday Helper - Happy Pilgrim's Bounty! (11/22-11/28)")
		end
		if (holidayhelper_activeHolidays["winterVeil"] == 1) then
			holidayhelper_print("Holiday Helper - Happy Winter Veil! (12/15 - 1/2)")
		end
		holidayhelper_playerName = UnitName("player")
	end
	
	if (holidayhelper_enable and event == "COMBAT_LOG_EVENT_UNFILTERED") then
		timestamp, eventX, hideCaster, guid, name = ...
		if guid ~= nil and name ~= holidayhelper_playerName then
			if holidayhelper_scannedPlayers[guid] ~= 1 then
				holidayhelper_scannedPlayers[guid] = 1
				alertIt = holidayhelper_checkGUID(guid,nil)
				if alertIt == true then
					locClass, engClass, locRace, engRace = GetPlayerInfoByGUID(guid)
					msg = engRace.." "..engClass.." named "..name.." detected nearby, /target "..name
					holidayhelper_print(msg)
					holidayhelper_macroUpdate(name)
				end
			end
		end
	end
	
	if (holidayhelper_enable and event == "UPDATE_MOUSEOVER_UNIT") then
		holidayhelper_checkUnit("mouseover")
	end
	if (holidayhelper_enable and event == "PLAYER_TARGET_CHANGED") then
		holidayhelper_checkUnit("target")
	end
	
end

function holidayhelper_onLoad (self)
	self:RegisterEvent("UNIT_AURA")
	self:RegisterEvent("PLAYER_LOGIN")
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	self:RegisterEvent("UPDATE_MOUSEOVER_UNIT")
	self:RegisterEvent("PLAYER_TARGET_CHANGED")
	self:RegisterEvent("QUEST_QUERY_COMPLETE")
end

function holidayhelper_getFactionInfo()
	holidayhelper_playerFaction = UnitFactionGroup("player")
	holidayhelper_scryerHated = false
	holidayhelper_aldorHated = false
	for factionIndex = 1, GetNumFactions() do
		name, description, standingId, bottomValue, topValue, earnedValue = GetFactionInfo(factionIndex)
		if (name == "Scryers") and (earnedValue < 0) then
			holidayhelper_scryerHated = true
		elseif (name == "Aldor") and (earnedValue < 0) then
			holidayhelper_aldorHated = true
		end
	end
end

function holidayhelper_onSlash(args)
	if(args == "enable") then
		holidayhelper_enable = true
		holidayhelper_onEnable()
		holidayhelper_print("Holiday Helper Mod enabled!")
	elseif(args == "disable") then
		holidayhelper_enable = false
		holidayhelper_onDisable()
		holidayhelper_print("Holiday Helper Mod disabled!")
	elseif(args == "tokens") then
		holidayhelper_tokens()
	elseif(args == "wands") then
		holidayhelper_wandStatus()
	elseif(args == "macro") then
		holidayhelper_macroCreate()
	elseif(args == "test") then
		holidayhelper_test()
	end
end

function holidayhelper_test()
end

function holidayhelper_onEnable()
	holidayhelper_createStaticWaypoints()
	holidayhelper_generateTrackingDict()
end

function holidayhelper_onDisable()
	holidayhelper_clearStaticWaypoints()
end

function holidayhelper_print(arg)
	DEFAULT_CHAT_FRAME:AddMessage(arg)
end

function holidayhelper_getActiveHolidays()
	weekday, month, day, year = CalendarGetDate()
	if ((month == 10) and (day >= 18) and (day <= 31)) then
		holidayhelper_activeHolidays["hallowsEnd"] = 1
	end
	if ((month == 11) and (day >= 22) and (day <= 28)) then
		holidayhelper_activeHolidays["pilgrimsBounty"] = 1
	end
	if ((month == 12) and (day >= 15)) or  ((month == 1) and (day <= 2)) then
		holidayhelper_activeHolidays["winterVeil"] = 1
	end
	
	if ((month == 1) and (day >= 22)) or  ((month == 2) and (day <= 11)) then
		holidayhelper_activeHolidays["lunarFestival"] = 1
	end
	if ((month == 6) and (day >= 21)) or  ((month == 7) and (day <= 5)) then
		holidayhelper_activeHolidays["midsummerFireFestival"] = 1
	end
	if ((month == 9) and (day >= 20)) or  ((month == 10) and (day <= 5)) then
		holidayhelper_activeHolidays["brewfest"] = 1
	end
	
	if ((month == 2) and (day >= 5) and (day <= 20)) then
		holidayhelper_activeHolidays["loveIsInTheAir"] = 1
	end
	if ((month == 4) and (day >= 8) and (day <= 14)) then
		holidayhelper_activeHolidays["noblegarden"] = 1
	end

end

-- TOKENS FUNCTIONS

function holidayhelper_tokens()
	local tokensRequired = nil
	local msg
	
	if (holidayhelper_activeHolidays["noblegarden"] == 1) then
		tokensRequired = holidayhelper_numNoblegardenChocolatesRequired()
		if (tokensRequired == 0) then
			msg = "You have collected all necessary tokens for Noblegarden"
		else
			msg = "You still need to collect " .. tokensRequired .. " Noblegarden Chocolates"
		end
		holidayhelper_print(msg)
	end
	
	if (holidayhelper_activeHolidays["midsummerFireFestival"] == 1) then
		tokensRequired = holidayhelper_numBurningBlossomsRequired()
		if (tokensRequired == 0) then
			msg = "You have collected all necessary tokens for Midsummer Fire Festival"
		else
			id, name, points, completed = GetAchievementInfo(271)
			if completed then
				msg = "You still need to collect " .. tokensRequired .. " Burning Blossoms"
			else
				msg = "You still need to collect " .. tokensRequired .. " Burning Blossoms, maybe more if you're not good at juggling"
			end
		end
		holidayhelper_print(msg)
	end
	
	if (holidayhelper_activeHolidays["brewfest"] == 1) then
		tokensRequired = holidayhelper_numBrewfestTokensRequired()
		if (tokensRequired == 0) then
			msg = "You have collected all necessary tokens for Brewfest...*hic*!"
		else
			msg = "You shtill need to collect " .. tokensRequired .. " Brewfest Tokens..*hic*!"
		end
		holidayhelper_print(msg)
	end
	
	if (holidayhelper_activeHolidays["hallowsEnd"] == 1) then
		tokensRequired = holidayhelper_numTrickyTreatsRequired()
		if (tokensRequired == 0) then
			msg = "You have collected all necessary tokens for Hallow's End"
		else
			msg = "You still need to collect as many as " .. tokensRequired .. " Tricky Treats"
		end
		holidayhelper_print(msg)
	end
end

-- WAYPOINTS FUNCTIONS

function holidayhelper_createStaticWaypoints()
	if TomTom then
		holidayhelper_clearStaticWaypoints()
		if (holidayhelper_activeHolidays["hallowsEnd"] == 1) then
			t = holidayhelper_candyBucketWaypointTable()
			for i=1,#t do
				l = t[i]
				uid = TomTom:AddMFWaypoint(nameToMapId[l["z"]], nil, l["x"]/100, l["y"]/100, {title = ("Candy Bucket - "..l["name"]), persistent=false, minimap=false})
				table.insert(holidayhelper_staticWaypoints,uid)
			end
		end
		if (holidayhelper_activeHolidays["midsummerFireFestival"] == 1) then
			t = holidayhelper_flamesWaypointTable()
			for i=1,#t do
				l = t[i]
				uid = TomTom:AddMFWaypoint(nameToMapId[l["z"]], nil, l["x"]/100, l["y"]/100, {title = ("Flame - "..l["name"]), persistent=false, minimap=false})
				table.insert(holidayhelper_staticWaypoints,uid)
			end
		end
		if (holidayhelper_activeHolidays["lunarFestival"] == 1) then
			t = holidayhelper_lunarEldersTable()
			for i=1,#t do
				l = t[i]
				uid = TomTom:AddMFWaypoint(nameToMapId[l["z"]], nil, l["x"]/100, l["y"]/100, {title = (l["name"]), persistent=false, minimap=false})
				table.insert(holidayhelper_staticWaypoints,uid)
			end
		end
	end
end

function holidayhelper_clearStaticWaypoints()
	if TomTom then
		for i=1,#holidayhelper_staticWaypoints do
			uid = holidayhelper_staticWaypoints[i]
			TomTom:RemoveWaypoint(uid)
		end
	end
end

-- TRACKING FUNCTIONS

function holidayhelper_generateTrackingDict()
	holidayhelper_raceClassCombosTracking = {}
	achievementID = nil
	raceClassCombos = {}
	if (holidayhelper_activeHolidays["pilgrimsBounty"] == 1) then
		achievementID = 3559
		raceClassCombos = {
			{race="BloodElf",engClass="ROGUE"},
			{race="Dwarf",engClass="ROGUE"},
			{race="Gnome",engClass="ROGUE"},
			{race="Human",engClass="ROGUE"},
			{race="NightElf",engClass="ROGUE"},
			{race="Orc",engClass="ROGUE"},
			{race="Troll",engClass="ROGUE"},
			{race="Scourge",engClass="ROGUE"}
		}
	elseif (holidayhelper_activeHolidays["winterVeil"] == 1) then
		achievementID = 1687
		raceClassCombos = {
			{race="Orc",engClass="DEATHKNIGHT"},
			{race="Tauren",engClass="SHAMAN"},
			{race="Scourge",engClass="ROGUE"},
			{race="Gnome",engClass="MAGE"},
			{race="BloodElf",engClass="WARLOCK"},
			{race="Human",engClass="WARRIOR"},
			{race="NightElf",engClass="DRUID"},
			{race="Troll",engClass="HUNTER"},
			{race="Dwarf",engClass="PALADIN"},
			{race="Draenei",engClass="PRIEST"}
		}
	elseif (holidayhelper_activeHolidays["loveIsInTheAir"] == 1) then
		achievementID = 1699
		raceClassCombos = {
			{race="Gnome",engClass="WARLOCK"},
			{race="Human",engClass="DEATHKNIGHT"},
			{race="Orc",engClass="SHAMAN"},
			{race="Scourge",engClass="WARRIOR"},
			{race="BloodElf",engClass="MAGE"},
			{race="Dwarf",engClass="HUNTER"},
			{race="Orc",engClass="DEATHKNIGHT"},
			{race="NightElf",engClass="PRIEST"},
			{race="Tauren",engClass="DRUID"},
			{race="Troll",engClass="ROGUE"},
			{race="Draenei",engClass="PALADIN"}
		}
	elseif (holidayhelper_activeHolidays["noblegarden"] == 1) then
		achievementID = 2422
		raceClassCombos = {
			{race="BloodElf",engClass="ANY"},
			{race="Draenei",engClass="ANY"},
			{race="Dwarf",engClass="ANY"},
			{race="Gnome",engClass="ANY"},
			{race="Goblin",engClass="ANY"},
			{race="Human",engClass="ANY"},
			{race="NightElf",engClass="ANY"},
			{race="Orc",engClass="ANY"},
			{race="Tauren",engClass="ANY"},
			{race="Troll",engClass="ANY"},
			{race="Scourge",engClass="ANY"},
			{race="Worgen",engClass="ANY"}
		}
	end

	
	if (achievementID ~= nil) then
		for i=1,#raceClassCombos do
			cName, _, completed = GetAchievementCriteriaInfo(achievementID,i)
			if completed == false then
				race = raceClassCombos[i]["race"]
				engClass = raceClassCombos[i]["engClass"]
				holidayhelper_raceClassCombosTracking[race] = engClass
			end
		end
	end
end

function holidayhelper_checkUnit(unit)
	racesToIcon = {Draenei=1,Dwarf=2,Gnome=3,Human=4,NightElf=5,Worgen=6,BloodElf=1,Goblin=2,Orc=3,Tauren=4,Troll=5,Scourge=6}
	-- return if don't have needed item
	itemIDNeeded = nil
	if (holidayhelper_activeHolidays["pilgrimsBounty"] == 1) then
		itemIDNeeded = 44812
	elseif (holidayhelper_activeHolidays["winterVeil"] == 1) then
		itemIDNeeded = 34191
	elseif (holidayhelper_activeHolidays["loveIsInTheAir"] == 1) then
		itemIDNeeded = 22218
	elseif (holidayhelper_activeHolidays["noblegarden"] == 1) then
		itemIDNeeded = 45073
	elseif (itemIDNeeded == nil) or (GetItemCount(itemIDNeeded) == 0) then
		return
	end
	if holidayhelper_playerName == UnitName(unit) then
		return
	end
	
	guid = UnitGUID(unit)
	level = UnitLevel(unit)
	
	trackIt = holidayhelper_checkGUID(guid,level)
	if trackIt == true then
		if holidayhelper_trackedPlayers[guid] ~= 2 then
			name = UnitName(unit)
			locClass, engClass, locRace, engRace = GetPlayerInfoByGUID(guid)
			iconToUse = racesToIcon[engRace]
			currTargetIcon = GetRaidTargetIndex(unit)
			if currTargetIcon == iconToUse then
				return
			end
			SetRaidTargetIcon(unit,iconToUse)
			if holidayhelper_trackedPlayers[guid] ~= 1 then
				msg = engClass.." "..engRace.." found named "..name..", raid icon set"
				if (holidayhelper_activeHolidays["noblegarden"] == 1) then
					msg = "Female level 18+ "..engRace.." found named "..name..", raid icon set"
				end
				holidayhelper_print(msg)
			end
			holidayhelper_trackedPlayers[guid] = 1
		end
	end
end

function holidayhelper_checkGUID(guid,level)
	if guid == nil  or guid == "0x0000000000000000" then
		return false
	end
	locClass, engClass, locRace, engRace, gender = GetPlayerInfoByGUID(guid)
	if engRace == nil or engClass == nil then
		return false
	end
	if (holidayhelper_activeHolidays["noblegarden"] == 1) then
		if level == nil or gender == nil then
			return false
		elseif level >= 18 and gender == 3 and holidayhelper_raceClassCombosTracking[engRace] == "ANY" then
			return true
		end
	elseif holidayhelper_raceClassCombosTracking[engRace] == engClass then
		return true
	end
	return false
end


-- MACRO FUNCTIONS

function holidayhelper_macroCreate()
	local macroID = GetMacroIndexByName("HolidayHelper")
	if not macroID or macroID == 0 then
		if select(2, GetNumMacros()) >= 18 then
			holidayhelper_print("Holiday Helper - All character macro slots are in use.")
		else
			CreateMacro("HolidayHelper", 1, "", 1, 1)
			holidayhelper_print("Holiday Helper - Macro created")	
		end
	else
		holidayhelper_print("Holiday Helper - Macro already created.")
	end
end

function holidayhelper_macroUpdate(targetName)
	if InCombatLockdown() then 
		return 
	end
	
	local macroID = GetMacroIndexByName("HolidayHelper")
	if not macroID then
		return
	end

	local body = "#showtooltip"
	body = body.."\n/target "..targetName
	icon = "INV_Misc_QuestionMark"
	if (holidayhelper_activeHolidays["loveIsInTheAir"] == 1) then
		icon = "INV_Misc_Dust_04"
	elseif (holidayhelper_activeHolidays["winterVeil"] == 1) then
		icon = "SPELL_Frost_Frostshock"
	elseif (holidayhelper_activeHolidays["pilgrimsBounty"] == 1) then
		icon = "INV_Torch_Unlit"
	end
	EditMacro(macroID, "HolidayHelper", icon, body, 1, 1)

end

-- HALLOWS END FUNCTIONS

function holidayhelper_numTrickyTreatsRequired()
	local numTrickyTreatsOwned = GetItemCount(33226)
	local numTrickyTreatsNotNeeded = 0

	-- 150 for Sinister Squashling and Hallowed Helm each
	name, _, completed = GetAchievementCriteriaInfo(292,1)
	if (completed or (GetItemCount(33154) > 0)) then 
		numTrickyTreatsNotNeeded = numTrickyTreatsNotNeeded + 150
	end
	name, _, completed = GetAchievementCriteriaInfo(292,2)
	if (completed) then 
		numTrickyTreatsNotNeeded = numTrickyTreatsNotNeeded + 150
	end
	
	-- 2 for Tooth Pick and GNERDS each
	id, name, points, completed = GetAchievementInfo(981)
	if (completed or (GetItemCount(37604) > 0)) then 
		numTrickyTreatsNotNeeded = numTrickyTreatsNotNeeded + 2
	end
	id, name, points, completed = GetAchievementInfo(1261)
	if (completed or (GetItemCount(37583) > 0)) then 
		numTrickyTreatsNotNeeded = numTrickyTreatsNotNeeded + 2
	end

	-- Up to 10 to get sick
	id, name, points, completed = GetAchievementInfo(288)
	if (completed) then
		numTrickyTreatsNotNeeded = numTrickyTreatsNotNeeded + 10;
	end

	local numTrickyTreatsNeeded = 314-numTrickyTreatsOwned-numTrickyTreatsNotNeeded
	if (numTrickyTreatsNeeded < 0) then
		numTrickyTreatsNeeded = 0
	end
	return numTrickyTreatsNeeded
end

function holidayhelper_candyBucketWaypointTable()
	t = {}
	bucketsHorde = {

		{ z="Hellfire Peninsula", x= 56.8, y=37.5, achievementID=968, criteriaID=5 },
		{ z="Hellfire Peninsula", x= 26.9, y=59.5, achievementID=968, criteriaID=4 },
		{ z="Zangarmarsh", x= 78.5, y=62.9, achievementID=968, criteriaID=14 },
		{ z="Blade's Edge Mountains", x= 76.2, y=60.4, achievementID=968, criteriaID=2 },
		{ z="Netherstorm", x= 32.0, y=64.4, achievementID=968, criteriaID=7 },
		{ z="Netherstorm", x= 43.3, y=36.1, achievementID=968, criteriaID=8 },
		{ z="Blade's Edge Mountains", x= 62.9, y=38.3, achievementID=968, criteriaID=1 },
		{ z="Blade's Edge Mountains", x= 53.4, y=55.5, achievementID=968, criteriaID=3 },
		{ z="Zangarmarsh", x= 30.6, y=50.9, achievementID=968, criteriaID=13 },
		{ z="Nagrand", x= 56.7, y=34.5, achievementID=968, criteriaID=6 },
		{ z="Terokkar Forest", x= 48.7, y=45.2, achievementID=968, criteriaID=12 },
		{ z="Shadowmoon Valley", x= 30.3, y=27.7, achievementID=968, criteriaID=10 },
		{ z="Silvermoon City", x= 79.4, y=57.7, achievementID=967, criteriaID=18 },
		{ z="Silvermoon City", x= 67.6, y=72.9, achievementID=967, criteriaID=17 },
		{ z="Eversong Woods", x= 48.2, y=47.9, achievementID=967, criteriaID=9 },
		{ z="Eversong Woods", x= 43.7, y=71.0, achievementID=967, criteriaID=8 },
		{ z="Ghostlands", x= 48.7, y=31.9, achievementID=967, criteriaID=10 },
		{ z="Eastern Plaguelands", x= 75.6, y=52.3, achievementID=967, criteriaID=7 },
		{ z="Western Plaguelands", x= 48.3, y=63.7, achievementID=967, criteriaID=26 },
		{ z="Tirisfal Glades", x= 83.0, y=72.1, achievementID=967, criteriaID=24 },
		{ z="Tirisfal Glades", x= 61.0, y=51.4, achievementID=967, criteriaID=23 },
		{ z="Undercity", x= 67.7, y=37.5, achievementID=967, criteriaID=25 },
		{ z="Silverpine Forest", x= 44.3, y=20.3, achievementID=967, criteriaID=19 },
		{ z="Silverpine Forest", x= 46.4, y=42.7, achievementID=967, criteriaID=20 },
		{ z="Hillsbrad Foothills", x= 57.9, y=47.3, achievementID=967, criteriaID=12 },
		{ z="Hillsbrad Foothills", x= 60.3, y=63.7, achievementID=967, criteriaID=11 },
		{ z="The Hinterlands", x= 31.8, y=57.9, achievementID=967, criteriaID=13 },
		{ z="The Hinterlands", x= 78.2, y=81.5, achievementID=967, criteriaID=14 },
		{ z="Arathi Highlands", x= 69.0, y=33.3, achievementID=967, criteriaID=1 },
		{ z="Searing Gorge", x= 39.5, y=66.1, achievementID=967, criteriaID=16 },
		{ z="Badlands", x= 18.4, y=42.7, achievementID=967, criteriaID=3 },
		{ z="Badlands", x= 65.8, y=35.6, achievementID=967, criteriaID=2 },
		{ z="Swamp of Sorrows", x= 71.6, y=14.1, achievementID=967, criteriaID=21 },
		{ z="Swamp of Sorrows", x= 46.9, y=56.9, achievementID=967, criteriaID=22 },
		{ z="Blasted Lands", x= 40.5, y=11.3, achievementID=967, criteriaID=4 },
		{ z="Northern Stranglethorn", x= 37.4, y=51.8, achievementID=967, criteriaID=15 },
		{ z="The Cape of Stranglethorn", x= 35.0, y=27.2, achievementID=967, criteriaID=6 },
		{ z="The Cape of Stranglethorn", x= 40.9, y=73.7, achievementID=967, criteriaID=5 },
		{ z="Azshara", x= 57.0, y= 50.3, achievementID=965, criteriaID=5 },
		{ z="Winterspring", x= 59.8, y= 51.1, achievementID=965, criteriaID=30 },
		{ z="Felwood", x= 44.7, y= 29.0, achievementID=965, criteriaID=11 },
		{ z="Ashenvale", x= 12.9, y= 34.1, achievementID=965, criteriaID=4 },
		{ z="Ashenvale", x= 38.6, y=42.4, achievementID=965, criteriaID=1 },
		{ z="Ashenvale", x= 50.2, y=67.3, achievementID=965, criteriaID=2 },
		{ z="Ashenvale", x= 73.9, y=60.6, achievementID=965, criteriaID=3 },
		{ z="Orgrimmar", x= 53.6, y=78.7, achievementID=965, criteriaID=20 },
		{ z="Durotar", x= 51.6, y=41.6, achievementID=965, criteriaID=8 },
		{ z="Northern Barrens", x= 67.3, y=74.6, achievementID=965, criteriaID=19 },
		{ z="Northern Barrens", x= 49.5, y=57.9, achievementID=965, criteriaID=16 },
		{ z="Northern Barrens", x= 56.2, y=40.0, achievementID=965, criteriaID=17 },
		{ z="Northern Barrens", x= 62.5, y=16.6, achievementID=965, criteriaID=18 },
		{ z="Stonetalon Mountains", x= 66.5, y=64.2, achievementID=965, criteriaID=24 },
		{ z="Stonetalon Mountains", x= 50.4, y=63.8, achievementID=965, criteriaID=25 },
		{ z="Desolace", x= 56.7, y=50.1, achievementID=965, criteriaID=6 },
		{ z="Desolace", x= 24.1, y=68.3, achievementID=965, criteriaID=7 },
		{ z="Thunder Bluff", x= 45.6, y=64.9, achievementID=965, criteriaID=28 },
		{ z="Mulgore", x= 46.8, y=60.4, achievementID=965, criteriaID=15 },
		{ z="Southern Barrens", x= 39.3, y=20.1, achievementID=965, criteriaID=23 },
		{ z="Southern Barrens", x= 40.7, y=69.3, achievementID=965, criteriaID=22 },
		{ z="Dustwallow Marsh", x= 36.8, y=32.4, achievementID=965, criteriaID=9 },
		{ z="Dustwallow Marsh", x= 41.9, y=74.1, achievementID=965, criteriaID=10 },
		{ z="Feralas", x= 41.4, y=15.7, achievementID=965, criteriaID=12 },
		{ z="Feralas", x= 52.0, y=47.6, achievementID=965, criteriaID=14 },
		{ z="Feralas", x= 74.8, y=45.1, achievementID=965, criteriaID=13 },
		{ z="Silithus", x= 55.5, y=36.8, achievementID=965, criteriaID=21 },
		{ z="Un'Goro Crater", x= 55.3, y=62.1, achievementID=965, criteriaID=29 },
		{ z="Tanaris", x= 52.6, y=27.1, achievementID=965, criteriaID=27 },
		{ z="Tanaris", x= 55.7, y=61.0, achievementID=965, criteriaID=26 }

	}
	bucketsAlliance = {	
		{ z="Dun Morogh", 					x=54.4, y=50.7, achievementID=966, criteriaID=2 },
		{ z="Duskwood", 					x=73.7, y=44.2, achievementID=966, criteriaID=3 },
		{ z="Eastern Plaguelands", 			x=75.5, y=52.3, achievementID=966, criteriaID=4 },
		{ z="Elwynn Forest", 				x=43.7, y=65.8, achievementID=966, criteriaID=5 },
		{ z="The Hinterlands", 				x=14.1, y=44.6, achievementID=966, criteriaID=6 },
		{ z="Ironforge", 					x=18.3, y=50.9, achievementID=966, criteriaID=7 },
		{ z="Loch Modan", 					x=35.5, y=48.5, achievementID=966, criteriaID=8 },
		{ z="Redridge Mountains", 			x=26.4, y=41.5, achievementID=966, criteriaID=9 },
		{ z="Stormwind City", 				x=60.5, y=75.3, achievementID=966, criteriaID=10 },
		{ z="The Cape of Stranglethorn", 	x=40.9, y=73.7, achievementID=966, criteriaID=1 },
		{ z="Westfall", 					x=52.9, y=53.7, achievementID=966, criteriaID=11 },
		{ z="Wetlands", 					x=10.8, y=60.9, achievementID=966, criteriaID=12 },

		{ z="Ashenvale", 					x=37,  y=49.2, achievementID=963, criteriaID=1 },
		{ z="Azuremyst Isle", 				x=48.4, y= 49, achievementID=963, criteriaID=2 },
		{ z="Bloodmyst Isle", 				x=55.7, y= 59.9, achievementID=963, criteriaID=3 },
		{ z="Darkshore", 					x=50.9, y= 18.9, achievementID=963, criteriaID=4 },
		{ z="Darnassus", 					x=62.2, y= 33.1, achievementID=963, criteriaID=5 },
		{ z="Desolace", 					x=66.3, y= 6.5, achievementID=963, criteriaID=6 },
		{ z="Dustwallow Marsh", 			x=41.8, y= 74, achievementID=963, criteriaID=7 },
		{ z="Dustwallow Marsh", 			x=66.6, y= 45.2, achievementID=963, criteriaID=8 },
		{ z="The Exodar", 					x= 59.2, y= 18.4, achievementID=963, criteriaID=9 },
		{ z="Feralas", 						x= 46.3, y= 45.2, achievementID=963, criteriaID=10 },
		{ z="Northern Barrens", 			x= 67.3, y= 74.6, achievementID=963, criteriaID=11 },
		{ z="Silithus", 					x= 55.4, y= 36.7, achievementID=963, criteriaID=12 },
		{ z="Stonetalon Mountains", 		x= 40.5, y= 17.6, achievementID=963, criteriaID=13 },
		{ z="Tanaris", 						x= 52.5, y= 27.1, achievementID=963, criteriaID=14 },
		{ z="Teldrassil", 					x= 55.3, y= 52.2, achievementID=963, criteriaID=15 },
		{ z="Winterspring", 				x= 59.8, y= 51.2, achievementID=963, criteriaID=16 },
	
		{ z="Nagrand", 						x= 54.2, y= 75.9, achievementID=969, criteriaID=6 },
		{ z="Terokkar Forest", 				x= 56.6, y= 53.2, achievementID=969, criteriaID=12 },
		{ z="Shadowmoon Valley", 			x= 37.0, y= 58.3, achievementID=969, criteriaID=10 },
		{ z="Hellfire Peninsula", 			x= 54.2, y= 63.7, achievementID=969, criteriaID=4 },
		{ z="Hellfire Peninsula", 			x= 23.4, y= 36.4, achievementID=969, criteriaID=5 },
		{ z="Zangarmarsh", 					x= 78.4, y= 62.9, achievementID=969, criteriaID=13 },
		{ z="Zangarmarsh", 					x= 67.2, y= 48.9, achievementID=969, criteriaID=15 },
		{ z="Zangarmarsh", 					x= 41.9, y= 26.2, achievementID=969, criteriaID=14 },
		{ z="Blade's Edge Mountains", 		x= 35.8, y= 63.7, achievementID=969, criteriaID=2 },
		{ z="Blade's Edge Mountains", 		x= 61.1, y= 68.1, achievementID=969, criteriaID=3 },
		{ z="Blade's Edge Mountains", 		x= 62.9, y= 38.3, achievementID=969, criteriaID=1 },
		{ z="Netherstorm", 					x= 32.0, y= 64.6, achievementID=969, criteriaID=7 },
		{ z="Netherstorm", 					x= 43.3, y= 36.1, achievementID=969, criteriaID=8 }
	}
	bucketsScryerAlliance = {
		{ z="Shattrath City", 					x= 56.3, y= 81.9, achievementID=969, criteriaID=11 },
		{ z="Shadowmoon Valley", 			x= 56.4, y= 59.8, achievementID=969, criteriaID=9 }
	}

	bucketsAldorAlliance = {
		{ z="Shattrath City", 					x= 28.2, y= 49.1, achievementID=969, criteriaID=11 },
		{ z="Shadowmoon Valley", 			x= 61.0, y= 28.2, achievementID=969, criteriaID=9 }
	}

	bucketsScryerHorde = {
		{ z="Shattrath City", 					x= 56.3, y= 81.9, achievementID=968, criteriaID=11 },
		{ z="Shadowmoon Valley", 			x= 56.4, y= 59.8, achievementID=968, criteriaID=9 }
	}

	bucketsAldorHorde = {
		{ z="Shattrath City", 					x= 28.2, y= 49.1, achievementID=968, criteriaID=11 },
		{ z="Shadowmoon Valley", 			x= 61.0, y= 28.2, achievementID=968, criteriaID=9 }
	}
	buckets = {}
	bucketsAldor = {}
	bucketsScryer = {}
	
	if (holidayhelper_playerFaction == "Alliance") then
		buckets = bucketsAlliance
		if holidayhelper_aldorHated == false then
			bucketsAldor = bucketsAldorAlliance
		end
		if holidayhelper_scryerHated == false then
			bucketsScryer = bucketsScryerAlliance
		end
	end
	if (holidayhelper_playerFaction == "Horde") then
		buckets = bucketsHorde
		if holidayhelper_aldorHated == false then
			bucketsAldor = bucketsAldorHorde
		end
		if holidayhelper_scryerHated == false then
			bucketsScryer = bucketsScryerHorde
		end
	end
	
	for i=1,#buckets do
		l = buckets[i]
		name, _, completed = GetAchievementCriteriaInfo(l["achievementID"],l["criteriaID"])
		if completed == false then
			l["name"] = name
			table.insert(t,l)
		end
	end
	for i=1,#bucketsAldor do
		l = bucketsAldor[i]
		name, _, completed = GetAchievementCriteriaInfo(l["achievementID"],l["criteriaID"])
		if completed == false then
			l["name"] = "Aldor"
			table.insert(t,l)
		end
	end
	for i=1,#bucketsScryer do
		l = bucketsScryer[i]
		name, _, completed = GetAchievementCriteriaInfo(l["achievementID"],l["criteriaID"])
		if completed == false then
			l["name"] = "Scryer"
			table.insert(t,l)
		end
	end
	return t
end

function holidayhelper_wandStatus()
	wands = { 
		{name="Bat",itemID=20410},
		{name="Ghost",itemID=20409},
		{name="Leper Gnome",itemID=20399},
		{name="Ninja",itemID=20398},
		{name="Pirate",itemID=20397},
		{name="Skeleton",itemID=20411},
		{name="Wisp",itemID=20414}
	}
	haveWands = ""
	needWands = ""
	for i=1,#wands do
		name = wands[i]["name"]
		itemID = wands[i]["itemID"]
		cName, _, completed = GetAchievementCriteriaInfo(283,i)
		if completed == false then
			if needWands ~= "" then
				needWands = needWands .. ", "
			end
			needWands = needWands .. name
		end
		if GetItemCount(itemID) > 0 then
			if haveWands ~= "" then
				haveWands = haveWands .. ", "
			end
			haveWands = haveWands .. name
		end
	end
	if needWands ~= "" then
		msg = "NEED: " .. needWands
		holidayhelper_print(msg)
	end
	if haveWands ~= "" then
		msg = "HAVE: " .. haveWands
		holidayhelper_print(msg)
	end
end

-- NOBLEGARDEN FUNCTIONS

function holidayhelper_numNoblegardenChocolatesRequired()
	local numChocolatesOwned = GetItemCount(44791)
	local numChocolatesNotNeeded = 0

	-- 100 for Chocoholic
	name, _, completed, quantity = GetAchievementCriteriaInfo(2418,1)
	if (completed) then
		numChocolatesNotNeeded = numChocolatesNotNeeded + 100
	else
		numChocolatesNotNeeded = numChocolatesNotNeeded + quantity
	end
	
	-- 100 for Spring Rabbit's Foot
	if (holidayhelper_playerFaction == "Alliance") then
		id, name, points, completed = GetAchievementInfo(2419)
	else
		id, name, points, completed = GetAchievementInfo(2497)
	end
	if (completed or (GetItemCount(44794) > 0) or IsSpellKnown(61725)) then 
		numChocolatesNotNeeded = numChocolatesNotNeeded + 100
	end
	
	-- 50 for Spring Flowers
	id, name, points, completed = GetAchievementInfo(2422)
	if (completed or (GetItemCount(45073) > 0)) then 
		numChocolatesNotNeeded = numChocolatesNotNeeded + 50
	end
	-- 50 for Spring Robes
	id, name, points, completed = GetAchievementInfo(2436)
	if (completed or (GetItemCount(44800) > 0)) then 
		numChocolatesNotNeeded = numChocolatesNotNeeded + 50
	end
	-- 25 for White Tuxedo Shirt and Black Tuxedo Pants each
	id, name, points, completed = GetAchievementInfo(2576)
	if (completed or (GetItemCount(6833) > 0)) then 
		numChocolatesNotNeeded = numChocolatesNotNeeded + 25
	end
	if (completed or (GetItemCount(6835) > 0)) then 
		numChocolatesNotNeeded = numChocolatesNotNeeded + 25
	end
	-- 5 for Noblegarden Egg
	if (holidayhelper_playerFaction == "Alliance") then
		id, name, points, completed = GetAchievementInfo(2421)
	else
		id, name, points, completed = GetAchievementInfo(2420)
	end
	if (completed or (GetItemCount(44818) > 0)) then 
		numChocolatesNotNeeded = numChocolatesNotNeeded + 5
	end

	local numChocolatesNeeded = 355-numChocolatesOwned-numChocolatesNotNeeded
	if (numChocolatesNeeded < 0) then
		numChocolatesNeeded = 0
	end
	return numChocolatesNeeded
	
end

-- MIDSUMMER FIRE FESTIVAL FUNCTIONS

function holidayhelper_numBurningBlossomsRequired()
	local numBlossomsOwned = GetItemCount(23247)
	local numBlossomsNotNeeded = 0

	-- 100 for Vestment of Summer
	id, name, points, completed = GetAchievementInfo(271)
	if (completed or (GetItemCount(34685) > 0)) then 
		numBlossomsNotNeeded = numBlossomsNotNeeded + 100
	end
	-- 200 for Sandles of Summer
	id, name, points, completed = GetAchievementInfo(271)
	if (completed or (GetItemCount(34683) > 0)) then 
		numBlossomsNotNeeded = numBlossomsNotNeeded + 200
	end
	-- 100 for mantle of Summer
	id, name, points, completed = GetAchievementInfo(271)
	if (completed or (GetItemCount(23324) > 0)) then 
		numBlossomsNotNeeded = numBlossomsNotNeeded + 100
	end
	-- Up to 10 for torch juggling
	id, name, points, completed = GetAchievementInfo(271)
	if (completed) then
		numBlossomsNotNeeded = numBlossomsNotNeeded + 10
	else
		numTorches = GetItemCount(34599)
		if numTorches < 10 then
			numTorches = 10
		end
		numBlossomsNotNeeded = numBlossomsNotNeeded + numTorches
	end

	local numBlossomsNeeded = 410-numBlossomsOwned-numBlossomsNotNeeded
	if (numBlossomsNeeded < 0) then
		numBlossomsNeeded = 0
	end
	return numBlossomsNeeded
	
end

function holidayhelper_flamesWaypointTable()
	t = {}
	flamesHordeDesecrate = {
		{ z="Ashenvale", x=87, y=42, achievementID=1032 , criteriaID=1 },
		{ z="Azuremyst Isle", x=44, y=53, achievementID=1032 , criteriaID=2 },
		{ z="Bloodmyst Isle", x=55, y=69, achievementID=1032 , criteriaID=3 },
		{ z="Darkshore", x=49, y=23, achievementID=1032 , criteriaID=4 },
		{ z="Desolace", x=65, y=17, achievementID=1032 , criteriaID=5 },
		{ z="Dustwallow Marsh", x=62, y=40, achievementID=1032 , criteriaID=6 },
		{ z="Feralas", x=47, y=44, achievementID=1032 , criteriaID=7 },
		{ z="Silithus", x=60, y=33, achievementID=1032 , criteriaID=8 },
		{ z="Southern Barrens", x=48, y=72, achievementID=1032 , criteriaID=9 },
		{ z="Tanaris", x=52, y=29, achievementID=1032 , criteriaID=10 },
		{ z="Teldrassil", x=55, y=60, achievementID=1032 , criteriaID=11 },
		{ z="Winterspring", x=62, y=47, achievementID=1032 , criteriaID=12 },
		{ z="Arathi Highlands", x=44, y=46, achievementID=1031 , criteriaID=1 },
		{ z="Blasted Lands", x=46, y=14, achievementID=1031 , criteriaID=2 },
		{ z="Burning Steppes", x=68, y=60, achievementID=1031 , criteriaID=3 },
		{ z="Dun Morogh", x=54, y=45, achievementID=1031 , criteriaID=4 },
		{ z="Duskwood", x=73, y=55, achievementID=1031 , criteriaID=5 },
		{ z="Elwynn Forest", x=43, y=63, achievementID=1031 , criteriaID=6 },
		{ z="Loch Modan", x=32, y=40, achievementID=1031 , criteriaID=7 },
		{ z="Northern Stranglethorn", x=51, y=63, achievementID=1031 , criteriaID=8 },
		{ z="Redridge Mountains", x=24, y=53, achievementID=1031 , criteriaID=9 },
		{ z="The Cape of Stranglethorn", x=52, y=67, achievementID=1031 , criteriaID=10 },
		{ z="The Hinterlands", x=14, y=50, achievementID=1031 , criteriaID=11 },
		{ z="Western Plaguelands", x=43, y=82, achievementID=1031 , criteriaID=12 },
		{ z="Westfall", x=45, y=62, achievementID=1031 , criteriaID=13 },
		{ z="Wetlands", x=13, y=47, achievementID=1031 , criteriaID=14 },
		{ z="Blade's Edge Mountains", x=42, y=66, achievementID=1033 , criteriaID=1 },
		{ z="Hellfire Peninsula", x=62, y=58, achievementID=1033 , criteriaID=2 },
		{ z="Nagrand", x=50, y=70, achievementID=1033, criteriaID=3 },
		{ z="Netherstorm", x=31, y=63, achievementID=1033 , criteriaID=4 },
		{ z="Shadowmoon Valley", x=40, y=55, achievementID=1033 , criteriaID=5 },
		{ z="Terokkar Forest", x=55, y=55, achievementID=1033 , criteriaID=6 },
		{ z="Zangarmarsh", x=69, y=52, achievementID=1033 , criteriaID=7 },
		{ z="Borean Tundra", x=55, y=20, achievementID=6010 , criteriaID=2 },
		{ z="Crystalsong Forest", x=78, y=75, achievementID=6010 , criteriaID=8 },
		{ z="Dragonblight", x=75, y=44, achievementID=6010 , criteriaID=1 },
		{ z="Grizzly Hills", x=34, y=61, achievementID=6010 , criteriaID=7 },
		{ z="Howling Fjord", x=58, y=16, achievementID=6010 , criteriaID=3 },
		{ z="Sholazar Basin", x=47, y=66, achievementID=6010 , criteriaID=4 },
		{ z="The Storm Peaks", x=42, y=87, achievementID=6010 , criteriaID=5 },
		{ z="Zul'Drak", x=41, y=61, achievementID=6010 , criteriaID=6 },
		{ z="Twilight Highlands", x=47, y=28, achievementID=6014 , criteriaID=1 },
		{ z="Uldum", x=53, y=32, achievementID=6014 , criteriaID=2 }
	}
	flamesHordeHonor = {
		{ z="Ashenvale", x=51, y=66, achievementID=1026 , criteriaID=1 },
		{ z="Desolace", x=26, y=76, achievementID=1026 , criteriaID=2 },
		{ z="Durotar", x=52, y=47, achievementID=1026 , criteriaID=3 },
		{ z="Dustwallow Marsh", x=33, y=30, achievementID=1026 , criteriaID=4 },
		{ z="Feralas", x=72, y=47, achievementID=1026 , criteriaID=5 },
		{ z="Mulgore", x=51, y=59, achievementID=1026 , criteriaID=6 },
		{ z="Northern Barrens", x=50, y=55, achievementID=1026 , criteriaID=7 },
		{ z="Silithus", x=51, y=41, achievementID=1026 , criteriaID=8 },
		{ z="Southern Barrens", x=41, y=68, achievementID=1026 , criteriaID=9 },
		{ z="Stonetalon Mountains", x=53, y=62, achievementID=1026 , criteriaID=10 },
		{ z="Tanaris", x=49, y=27, achievementID=1026 , criteriaID=11 },
		{ z="Winterspring", x=59, y=47, achievementID=1026 , criteriaID=12 },
		{ z="Arathi Highlands", x=69, y=42, achievementID=1025 , criteriaID=1 },
		{ z="Badlands", x=24, y=37, achievementID=1025 , criteriaID=2 },
		{ z="Burning Steppes", x=51, y=29, achievementID=1025 , criteriaID=3 },
		{ z="Eversong Woods", x=46, y=50, achievementID=1025, criteriaID=4 },
		{ z="Ghostlands", x=46, y=26, achievementID=1025 , criteriaID=5 },
		{ z="Hillsbrad Foothills", x=55, y=50, achievementID=1025 , criteriaID=6 },
		{ z="Northern Stranglethorn", x=41, y=51, achievementID=1025 , criteriaID=7 },
		{ z="Silverpine Forest", x=50, y=38, achievementID=1025 , criteriaID=8 },
		{ z="Swamp of Sorrows", x=76, y=14, achievementID=1025 , criteriaID=9 },
		{ z="The Cape of Stranglethorn", x=50, y=70, achievementID=1025 , criteriaID=10 },
		{ z="The Hinterlands", x=14, y=50, achievementID=1025 , criteriaID=11 },
		{ z="Tirisfal Glades", x=57, y=52, achievementID=1025 , criteriaID=12 },
		{ z="Blade's Edge Mountains", x=50, y=59, achievementID=1027 , criteriaID=1 },
		{ z="Hellfire Peninsula", x=55, y=40, achievementID=1027 , criteriaID=2 },
		{ z="Nagrand", x=51, y=34, achievementID=1027 , criteriaID=3 },
		{ z="Netherstorm", x=32, y=68, achievementID=1027 , criteriaID=4 },
		{ z="Shadowmoon Valley", x=33, y=30, achievementID=1027 , criteriaID=5 },
		{ z="Terokkar Forest", x=52, y=43, achievementID=1027 , criteriaID=6 },
		{ z="Zangarmarsh", x=36, y=52, achievementID=1027 , criteriaID=7 },
		{ z="Borean Tundra", x=51, y=12, achievementID=6009 , criteriaID=2 },
		{ z="Crystalsong Forest", x=80, y=53, achievementID=6009 , criteriaID=8 },
		{ z="Dragonblight", x=39, y=48, achievementID=6009 , criteriaID=1 },
		{ z="Grizzly Hills", x=19, y=61, achievementID=6009 , criteriaID=7 },
		{ z="Howling Fjord", x=48, y=13, achievementID=6009 , criteriaID=3 },
		{ z="Sholazar Basin", x=47, y=62, achievementID=6009 , criteriaID=4 },
		{ z="The Storm Peaks", x=40, y=86, achievementID=6009 , criteriaID=5 },
		{ z="Zul'Drak", x=43, y=71, achievementID=6009 , criteriaID=6 },
		{ z="Deepholm", x=49, y=51, achievementID=6012 , criteriaID=4 },
		{ z="Mount Hyjal", x=63, y=23, achievementID=6012 , criteriaID=3 },
		{ z="Shimmering Expanse", x=49, y=42, achievementID=6012 , criteriaID=1 },
		{ z="Twilight Highlands", x=53, y=46, achievementID=6012 , criteriaID=2 },
		{ z="Uldum", x=53, y=34, achievementID=6012 , criteriaID=5 }
	}
	
	flamesAllianceHonor = {
		{ z="Ashenvale", x=87, y=42, achievementID=1023 , criteriaID=1 },
		{ z="Azuremyst Isle", x=44, y=53, achievementID=1023 , criteriaID=2 },
		{ z="Bloodmyst Isle", x=55, y=69, achievementID=1023 , criteriaID=3 },
		{ z="Darkshore", x=49, y=23, achievementID=1023 , criteriaID=4 },
		{ z="Desolace", x=65, y=17, achievementID=1023 , criteriaID=5 },
		{ z="Dustwallow Marsh", x=62, y=40, achievementID=1023 , criteriaID=6 },
		{ z="Feralas", x=47, y=44, achievementID=1023 , criteriaID=7 },
		{ z="Silithus", x=60, y=33, achievementID=1023 , criteriaID=8 },
		{ z="Southern Barrens", x=48, y=72, achievementID=1023 , criteriaID=9 },
		{ z="Tanaris", x=52, y=29, achievementID=1023 , criteriaID=10 },
		{ z="Teldrassil", x=55, y=60, achievementID=1023 , criteriaID=11 },
		{ z="Winterspring", x=62, y=47, achievementID=1023 , criteriaID=12 },
		{ z="Arathi Highlands", x=44, y=46, achievementID=1022 , criteriaID=1 },
		{ z="Blasted Lands", x=46, y=14, achievementID=1022 , criteriaID=2 },
		{ z="Burning Steppes", x=68, y=60, achievementID=1022 , criteriaID=3 },
		{ z="Dun Morogh", x=54, y=45, achievementID=1022 , criteriaID=4 },
		{ z="Duskwood", x=73, y=55, achievementID=1022 , criteriaID=5 },
		{ z="Elwynn Forest", x=43, y=63, achievementID=1022 , criteriaID=6 },
		{ z="Loch Modan", x=32, y=40, achievementID=1022 , criteriaID=7 },
		{ z="Northern Stranglethorn", x=51, y=63, achievementID=1022 , criteriaID=8 },
		{ z="Redridge Mountains", x=24, y=53, achievementID=1022 , criteriaID=9 },
		{ z="The Cape of Stranglethorn", x=52, y=67, achievementID=1022 , criteriaID=10 },
		{ z="The Hinterlands", x=14, y=50, achievementID=1022 , criteriaID=11 },
		{ z="Western Plaguelands", x=43, y=82, achievementID=1022 , criteriaID=12 },
		{ z="Westfall", x=45, y=62, achievementID=1022 , criteriaID=13 },
		{ z="Wetlands", x=13, y=47, achievementID=1022 , criteriaID=14 },
		{ z="Blade's Edge Mountains", x=42, y=66, achievementID=1024 , criteriaID=1 },
		{ z="Hellfire Peninsula", x=62, y=58, achievementID=1024 , criteriaID=2 },
		{ z="Nagrand", x=50, y=70, achievementID=1024, criteriaID=3 },
		{ z="Netherstorm", x=31, y=63, achievementID=1024 , criteriaID=4 },
		{ z="Shadowmoon Valley", x=40, y=55, achievementID=1024 , criteriaID=5 },
		{ z="Terokkar Forest", x=55, y=55, achievementID=1024 , criteriaID=6 },
		{ z="Zangarmarsh", x=69, y=52, achievementID=1024 , criteriaID=7 },
		{ z="Borean Tundra", x=55, y=20, achievementID=6008 , criteriaID=8 },
		{ z="Crystalsong Forest", x=78, y=75, achievementID=6008 , criteriaID=2 },
		{ z="Dragonblight", x=75, y=44, achievementID=6008 , criteriaID=1 },
		{ z="Grizzly Hills", x=34, y=61, achievementID=6008 , criteriaID=7 },
		{ z="Howling Fjord", x=58, y=16, achievementID=6008 , criteriaID=3 },
		{ z="Sholazar Basin", x=47, y=66, achievementID=6008 , criteriaID=4 },
		{ z="The Storm Peaks", x=42, y=87, achievementID=6008 , criteriaID=5 },
		{ z="Zul'Drak", x=41, y=61, achievementID=6008 , criteriaID=6 },
		{ z="Deepholm", x=49, y=51, achievementID=6011 , criteriaID=2 },
		{ z="Mount Hyjal", x=63, y=23, achievementID=6011 , criteriaID=5 },
		{ z="Shimmering Expanse", x=49, y=42, achievementID=6011 , criteriaID=4 },
		{ z="Twilight Highlands", x=47, y=28, achievementID=6011 , criteriaID=3 },
		{ z="Uldum", x=53, y=32, achievementID=6011 , criteriaID=1 }
	}
	flamesAllianceDesecrate = {
		{ z="Ashenvale", x=51, y=66, achievementID=1029 , criteriaID=1 },
		{ z="Desolace", x=26, y=76, achievementID=1029 , criteriaID=2 },
		{ z="Durotar", x=52, y=47, achievementID=1029 , criteriaID=3 },
		{ z="Dustwallow Marsh", x=33, y=30, achievementID=1029 , criteriaID=4 },
		{ z="Feralas", x=72, y=47, achievementID=1029 , criteriaID=5 },
		{ z="Mulgore", x=51, y=59, achievementID=1029 , criteriaID=6 },
		{ z="Northern Barrens", x=50, y=55, achievementID=1029 , criteriaID=7 },
		{ z="Silithus", x=51, y=41, achievementID=1029 , criteriaID=8 },
		{ z="Southern Barrens", x=41, y=68, achievementID=1029 , criteriaID=9 },
		{ z="Stonetalon Mountains", x=53, y=62, achievementID=1029 , criteriaID=10 },
		{ z="Tanaris", x=49, y=27, achievementID=1029 , criteriaID=11 },
		{ z="Winterspring", x=59, y=47, achievementID=1029 , criteriaID=12 },
		{ z="Arathi Highlands", x=69, y=42, achievementID=1028 , criteriaID=1 },
		{ z="Badlands", x=24, y=37, achievementID=1028 , criteriaID=2 },
		{ z="Burning Steppes", x=51, y=29, achievementID=1028 , criteriaID=3 },
		{ z="Eversong Woods", x=46, y=50, achievementID=1028, criteriaID=4 },
		{ z="Ghostlands", x=46, y=26, achievementID=1028 , criteriaID=5 },
		{ z="Hillsbrad Foothills", x=55, y=50, achievementID=1028 , criteriaID=6 },
		{ z="Northern Stranglethorn", x=41, y=51, achievementID=1028 , criteriaID=7 },
		{ z="Silverpine Forest", x=50, y=38, achievementID=1028 , criteriaID=8 },
		{ z="Swamp of Sorrows", x=76, y=14, achievementID=1028 , criteriaID=9 },
		{ z="The Cape of Stranglethorn", x=50, y=70, achievementID=1028 , criteriaID=10 },
		{ z="The Hinterlands", x=14, y=50, achievementID=1028 , criteriaID=11 },
		{ z="Tirisfal Glades", x=57, y=52, achievementID=1028 , criteriaID=12 },
		{ z="Blade's Edge Mountains", x=50, y=59, achievementID=1030 , criteriaID=1 },
		{ z="Hellfire Peninsula", x=55, y=40, achievementID=1030 , criteriaID=2 },
		{ z="Nagrand", x=51, y=34, achievementID=1030 , criteriaID=3 },
		{ z="Netherstorm", x=32, y=68, achievementID=1030 , criteriaID=4 },
		{ z="Shadowmoon Valley", x=33, y=30, achievementID=1030 , criteriaID=5 },
		{ z="Terokkar Forest", x=52, y=43, achievementID=1030 , criteriaID=6 },
		{ z="Zangarmarsh", x=36, y=52, achievementID=1030 , criteriaID=7 },
		{ z="Borean Tundra", x=51, y=12, achievementID=6007 , criteriaID=1 },
		{ z="Crystalsong Forest", x=80, y=53, achievementID=6007 , criteriaID=6 },
		{ z="Dragonblight", x=39, y=48, achievementID=6007 , criteriaID=8 },
		{ z="Grizzly Hills", x=19, y=61, achievementID=6007 , criteriaID=4 },
		{ z="Howling Fjord", x=48, y=13, achievementID=6007 , criteriaID=5 },
		{ z="Sholazar Basin", x=47, y=62, achievementID=6007 , criteriaID=7 },
		{ z="The Storm Peaks", x=40, y=86, achievementID=6007 , criteriaID=2 },
		{ z="Zul'Drak", x=43, y=71, achievementID=6007 , criteriaID=3 },
		{ z="Twilight Highlands", x=53, y=46, achievementID=6013 , criteriaID=1 },
		{ z="Uldum", x=53, y=34, achievementID=6013 , criteriaID=2 }
	}
	-- HORDE STEAL CAPITALS
	flamesHordeSteal = {
		{ z="Stormwind City", x=49, y=72, questID=9330,itemID=23182 },
		{ z="Ironforge", x=64, y=25, questID=9331,itemID=23183},
		{ z="Darnassus", x=55, y=91, questID=9332,itemID=23184 },
		{ z="The Exodar", x=41, y=26, questID=11933,itemID=35569 }
	}
	-- ALLIANCE STEAL CAPITALS
	flamesAllianceSteal = {
		{ z="Silvermoon City", x=70, y=43, questID=11935,itemID=35568 },
		{ z="Undercity", x=68, y=9, questID=9326,itemID=23181 },
		{ z="Orgrimmar", x=47, y=38, questID=9324,itemID=23179 },
		{ z="Thunder Bluff", x=21, y=26, questID=9325,itemID=23180 }
	}

	flamesHonor = {}
	flamesDesecrate = {}
	flamesSteal = {}
	if (holidayhelper_playerFaction == "Horde") then
		flamesHonor = flamesHordeHonor
		flamesDesecrate = flamesHordeDesecrate
		flamesSteal = flamesHordeSteal
	end
	if (holidayhelper_playerFaction == "Alliance") then
		flamesHonor = flamesAllianceHonor
		flamesDesecrate = flamesAllianceDesecrate
		flamesSteal = flamesAllianceSteal
	end
	for i=1,#flamesHonor do
		l = flamesHonor[i]
		name, _, completed = GetAchievementCriteriaInfo(l["achievementID"],l["criteriaID"])
		if completed == false then
			l["name"] = name.." - Honor"
			table.insert(t,l)
		end
	end
	for i=1,#flamesDesecrate do
		l = flamesDesecrate[i]
		name, _, completed = GetAchievementCriteriaInfo(l["achievementID"],l["criteriaID"])
		if completed == false then
			l["name"] = name.." - Desecrate"
			table.insert(t,l)
		end
	end
	-- get completed quests
	completedQuests = GetQuestsCompleted()
	for i=1,#flamesSteal do
		l = flamesSteal[i]
		if (completedQuests[l["questID"]] ~= 1) and (GetItemCount(l["itemID"]) == 0) then
			l["name"] = l["z"].." - Steal"
			table.insert(t,l)
		end
	end
	return t
end

-- BREWFEST FUNCTIONS

function holidayhelper_numBrewfestTokensRequired()
	local numTokensOwned = GetItemCount(23247)
	local numTokensNotNeeded = 0
	
	-- 200 for Brew of the Month membership
	id, name, points, completed = GetAchievementInfo(2796)
	if (completed or (GetItemCount(37736) > 0) or (GetItemCount(37737) > 0)) then 
		numTokensNotNeeded = numTokensNotNeeded + 200
	end
	-- 2 for Fresh Hops
	id, name, points, completed = GetAchievementInfo(303)
	if (completed or (GetItemCount(37750) > 0) or (GetItemCount(39476) > 0) or (GetItemCount(39477) > 0) or (GetItemCount(37816) > 0)) then 
		numTokensNotNeeded = numTokensNotNeeded + 2
	end
	
	local numTokensNeeded = 202-numTokensOwned-numTokensNotNeeded
	if (numTokensNeeded < 0) then
		numTokensNeeded = 0
	end
	return numTokensNeeded
end

-- LUNAR FESTIVAL FUNCTIONS

function holidayhelper_lunarEldersTable()
	t = {}
	elders = {
		{z="Deepholm", x=49.7, y=54.9, achievementID=6006 , criteriaID=1 },
		{z="Deepholm", x=27,7, y=69.2, achievementID=6006 , criteriaID=9 },
		{z="Mount Hyjal", x=62.5, y=22.8, achievementID=6006 , criteriaID=7 },
		{z="Mount Hyjal", x=26.7, y=62.0, achievementID=6006 , criteriaID=6 },
		{z="Shimmering Expanse", x=57.3, y=86.2, achievementID=6006 , criteriaID=8 },
		{z="Twilight Highlands", x=51.9, y=33.1, achievementID=6006 , criteriaID=5 },
		{z="Twilight Highlands", x=50.9, y=70.5, achievementID=6006 , criteriaID=4 },
		{z="Uldum", x=65.5, y=18.7, achievementID=6006 , criteriaID=2 },
		{z="Uldum", x=32.6, y=63.0, achievementID=6006 , criteriaID=3 },

		{z="Blasted Lands", x=54.3, y=49.5, achievementID=912 , criteriaID=2 },
		{z="Burning Steppes", x=53.2, y=24, achievementID=912 , criteriaID=10 },
		{z="Dun Morogh", x=53.9, y=49.8, achievementID=912 , criteriaID=1 },
		{z="Tirisfal Glades", x=61.7, y=53.7, achievementID= 912, criteriaID=13 },
		{z="The Hinterlands", x=49.9, y=47.9, achievementID=912 , criteriaID=11 },
		{z="Searing Gorge", x=21.1, y=78.8, achievementID=912 , criteriaID=12 },
		{z="Western Plaguelands", x=63.5, y=36.1, achievementID=912 , criteriaID=4 },
		{z="Western Plaguelands", x=69, y=73, achievementID=912 , criteriaID=17 },
		{z="Silverpine Forest", x=44.8, y=41.1, achievementID=912 , criteriaID=14 },
		{z="Burning Steppes", x=70.1, y=45.4, achievementID=912 , criteriaID=9 },
		{z="Loch Modan", x=33, y=46.5, achievementID=912 , criteriaID=7 },
		{z="Westfall", x=56.6, y=47, achievementID= 912, criteriaID=8 },
		{z="Eastern Plaguelands", x=75.7, y=54.6, achievementID= 912, criteriaID=16 },
		{z="Northern Stranglethorn", x=71, y=34.3, achievementID=912 , criteriaID=5 },
		{z="Elwynn Forest", x=39.6, y=63.5, achievementID= 912, criteriaID=3 },
		{z="Eastern Plaguelands", x=35.6, y=68.8, achievementID=912 , criteriaID=15 },
		{z="The Cape of Stranglethorn", x=40, y=72.5, achievementID=912 , criteriaID=6 },

		{z="Teldrassil", x=57.0, y=53.0, achievementID=911 , criteriaID=6 },
		{z="Silithus", x=53.0, y=35.5, achievementID=911 , criteriaID=21},
		{z="Mulgore", x=48.3, y=53.4, achievementID=911 , criteriaID=8 },
		{z="Winterspring", x=53.2, y=56.8, achievementID=911 , criteriaID=18 },
		{z="Tanaris", x=51.3, y=27.8, achievementID=911 , criteriaID=16 },
		{z="Feralas", x=76.7, y=37.9, achievementID=911 , criteriaID=10 },
		{z="Southern Barrens", x=41.5, y=47.5, achievementID=911 , criteriaID=4 },
		{z="Feralas", x=62, y=31, achievementID=911 , criteriaID=11 },
		{z="Northern Barrens", x=48.5, y=59.3, achievementID=911 , criteriaID=3 },
		{z="Thousand Needles", x=77.1, y=75.6, achievementID=911 , criteriaID=14 },
		{z="Felwood", x=38.3, y=52.9, achievementID=911 , criteriaID=12 },
		{z="Silithus", x=30.8, y=13.3, achievementID=911 , criteriaID=20 },
		{z="Tanaris", x=37.2, y=79.1, achievementID= 911, criteriaID=15 },
		{z="Ashenvale", x=35.6, y=48.9, achievementID=911 , criteriaID=9 },
		{z="Durotar", x=53.2, y=43.6, achievementID= 911, criteriaID=1 },
		{z="Azshara", x=64.7, y=79.3, achievementID= 911, criteriaID=2 },
		{z="Thousand Needles", x=46.4, y=51.0, achievementID=911 , criteriaID=13 },
		{z="Darkshore", x=49.5, y=19.0, achievementID=911 , criteriaID=7 },
		{z="Winterspring", x=60.1, y=49.9, achievementID= 911, criteriaID=19 },
		{z="Un'Goro Crater", x=50.4, y=76.1, achievementID=911 , criteriaID=17 },
		{z="Northern Barrens", x=68.4, y=70.0, achievementID=911 , criteriaID=5 },

		{z="Darnassus", x=39.1, y=31.9, achievementID=915 , criteriaID=1 },
		{z="Elwynn Forest", x=35, y=51, achievementID= 915, criteriaID=3 },
		{z="Ironforge", x=29.1, y=17.2, achievementID= 915, criteriaID=2 },

		{z="Undercity", x=67.4, y=39.1, achievementID= 914, criteriaID=3 },
		{z="Orgrimmar", x=52.4, y=60.0, achievementID=914 , criteriaID=1 },
		{z="Thunder Bluff", x=73.0, y=23.3, achievementID=914 , criteriaID=2 },

		{z="The Storm Peaks", x=41, y=84 , achievementID=1396 , criteriaID=13 },
		{z="The Storm Peaks", x=29, y=74 , achievementID=1396 , criteriaID=4 },
		{z="The Storm Peaks", x=30, y=38, achievementID=1396 , criteriaID=14 },
		{z="The Storm Peaks", x=64, y=51 , achievementID=1396 , criteriaID=18 },
		{z="Zul'Drak", x=58, y=56 , achievementID=1396 , criteriaID=11 },
		{z="Grizzly Hills", x= 60, y=28, achievementID= 1396, criteriaID=2 },
		{z="Grizzly Hills", x=80, y=37 , achievementID= 1396, criteriaID=9 },
		{z="Grizzly Hills", x=64, y=47 , achievementID=1396 , criteriaID=16 },
		{z="Dragonblight", x=49, y=78, achievementID=1396 , criteriaID=12 },
		{z="Dragonblight", x=35, y=48 , achievementID=1396 , criteriaID=17 },
		{z="Dragonblight", x=30, y=56, achievementID=1396 , criteriaID=3 },
		{z="Wintergrasp", x=49, y=14, achievementID=1396 , criteriaID=10 },
		{z="Sholazar Basin", x=63, y=49 , achievementID=1396 , criteriaID=8 },
		{z="Sholazar Basin", x=49, y=63 , achievementID=1396 , criteriaID=7 },
		{z="Borean Tundra", x=57, y=43 , achievementID=1396 , criteriaID=5 },
		{z="Borean Tundra", x=59, y=66 , achievementID=1396 , criteriaID=1 },
		{z="Borean Tundra", x=42, y=49 , achievementID=1396 , criteriaID=15 },
		{z="Borean Tundra", x=33, y=34 , achievementID=1396 , criteriaID=6 }
	}
	for i=1,#elders do
		l = elders[i]
		name, _, completed = GetAchievementCriteriaInfo(l["achievementID"],l["criteriaID"])
		if completed == false then
			l["name"] = name
			table.insert(t,l)
		end
	end
	return t
end
